#include <string.h>
#include "list.h"

#define first(list)	list->first
#define last(list)	list->last
#define next(elem)	((LISTELEM*)elem)->next
#define	prev(elem)	((LISTELEM*)elem)->prev

void* first_elem(LIST *list){
    return first(list);
}

void* last_elem(LIST *list){
    return last(list);
}

void* next_elem(void *elem){
    return next(elem);
}

void* prev_elem(void *elem){
    return prev(elem);
}

void add_to_list(LIST *list, void *elem){
    next(elem) = first(list);
    prev(elem) = NULL;
    if (next(elem) != NULL) prev(next(elem)) = elem;
    first(list) = elem;
    if (last(list) == NULL) last(list) = elem;
}

void add_to_list_back(LIST *list, void *elem){
    next(elem) = NULL;
    prev(elem) = last(list);
    if (prev(elem) != NULL) next(prev(elem)) = elem;
    last(list) = elem;
    if (first(list) == NULL) first(list) = elem;
}

void remove_from_list(LIST *list, void *elem){
    if (prev(elem) != NULL) next(prev(elem)) = next(elem); 
    if (next(elem) != NULL) prev(next(elem)) = prev(elem);
    if (elem == first(list)) first(list) = next(elem);
    if (elem == last(list))  last(list)  = prev(elem);
}

int list_count(LIST *list){
    int		count;
    void	*elem;

    count = 0;
    elem = first(list);
    while(elem != NULL){
	count++;
	elem = next(elem);
    }
    return count;
}
