#ifndef __SMBCTX_H__
#define __SMBCTX_H__

#include <time.h>
#include <pthread.h>
#include <libsmbclient.h>
#include "list.h"

typedef struct{
    char		reserved[sizeof(LISTELEM)];
    int			ref_count;
    time_t		atime;
    pthread_mutex_t	mutex;
    SMBCCTX		*ctx;
    hstring		name;
    char		data[64];
} SmbCtx;

int  SetSmbNetbiosName(const char *netbios_name);
int  SetSmbDebugLevel(int level);
int  GetSmbDebugLevel();
int  SetMaxSmbCtxCount(int count);
int  GetMaxSmbCtxCount();
int  SetSmbCtxUpdateInterval(int interval);
int  GetSmbCtxUpdateInterval();

void    AllocateSmbCtx();
void	DestroyUnusedCtx();

SmbCtx*	GetSmbCtx(const char *smbpath);
void	ReleaseSmbCtx(SmbCtx *smb, int clear_context);
void	LockSmbCtx(SmbCtx *smb);
int	TryLockSmbCtx(SmbCtx *smb);
void	UnlockSmbCtx(SmbCtx *smb);
void	RefreshCtx(SmbCtx *smb);
void	SmbCtxListRefresh(time_t atime);

#endif	/* __SMBCTX_H__ */
